
image: gitlab/dind
services:
  - docker:dind



variables:
  DOCKER_DRIVER: overlay
  APP_IMAGE: demo-cicd-image 
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA


before_script:
  - docker ps

stages:
  - build
  - deploy
  

# Verify it can build.

build:
  image: docker:stable
  stage: build
  services:
    - name: docker:dind
      entrypoint: ["env", "-u", "DOCKER_HOST"]
      command: ["dockerd-entrypoint.sh"]
  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
    # See https://github.com/docker-library/docker/pull/166
    DOCKER_TLS_CERTDIR: ""
  script:
    - echo $TAG_LATEST."====== Deploy to production server ======".$TAG_COMMIT
    # - mv $TARGET_ENV .env
    - docker build -t $TAG_COMMIT -t $TAG_LATEST docker
    # - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - echo $CI_REGISTRY_USER."====== Deploy to production server ======".$CI_REGISTRY."===pass===".$CI_BUILD_TOKEN
    #- docker login --username "$CI_REGISTRY_USER"  "$CI_REGISTRY" --password-stdin
    - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY --username $CI_REGISTRY_USER --password-stdin
    # - docker login -u "$CI_REGISTRY_USER" -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker push $TAG_COMMIT
    - docker push $TAG_LATEST
  only:
    - main
  tags:
    - development

deploy:
  image: alpine:3.14.10
  stage: deploy
  script:
    - chmod og= $ID_RSA
    - cat $ID_RSA
    - apk update && apk add openssh-client
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_HOST "echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY --username $CI_REGISTRY_USER --password-stdin"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_HOST "docker pull $TAG_COMMIT"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_HOST "docker container rm -f backend || true"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_HOST "docker run 
      --detach 
      --restart always 
      --name backend 
      --network service-network 
      --env HTTP_PORT=3000       
      --env VIRTUAL_HOST=$SERVER_NAME 
      --env LETSENCRYPT_HOST=$SERVER_NAME
      --env LETSENCRYPT_EMAIL="neil20fc@gmail.com"  
      --env REDIRECT_STATUS_CODE=301 
      $TAG_COMMIT "

  environment:
    name: production
    url: http://23.29.124.174
  only:
    - main
  tags:
    - development